<!-- This example requires Tailwind CSS v2.0+ -->
<template>
  <header
    class="bg-gray-200 rounded-md mt-20 mb-20 space-y-4 p-4 sm:px-8 sm:py-6 lg:p-4 xl:px-8 xl:py-6"
  >
    <div class="flex items-center justify-between">
      <div class="flex space-x-4 items-center text-sm font-medium">
        <div class="flex-auto flex space-x-4">Search by release date:</div>
        <Datepicker
          v-model="date"
          range
          :enableTimePicker="false"
          @update:modelValue="handleDate"
        ></Datepicker>
      </div>

      <button
        class="h-10 px-6 font-semibold rounded-full text-white bg-[#549DF2]"
        type="submit"
        @click="filterMoviesBaseReleaseData"
      >
        Search
      </button>
    </div>
  </header>
  <div ref="header" class="pt-10 grid lg:grid-cols-3 gap-16">
    <template v-for="(movie, index) in movies" :key="index">
      <movie-card
        :movie-generes="movie.genre_names"
        :release-date="movie.release_date"
        :poster-url="movie.poster_path"
        :title="movie.title"
        :all-generes="allGeneres"
        :movie-id="movie.id"
      ></movie-card>
    </template>
  </div>
  <pagination-module
    :result-index="resultIndex"
    :page-number="pageNumber"
    :total-pages="totalPages"
    @changePage="changePage"
    class="mt-20 mb-10"
  ></pagination-module>
</template>

<script>
import MovieDataService from "../../services/MovieDataService";
import MovieCard from "../movies/MovieCard.vue";
import PaginationModule from "../PaginationModule.vue";
import Datepicker from "@vuepic/vue-datepicker";
import "@vuepic/vue-datepicker/dist/main.css";

export default {
  components: {
    MovieCard,
    PaginationModule,
    Datepicker,
  },

  data() {
    return {
      moviesResponse: [],
      movies: [],
      allGeneres: [],
      title: "",
      resultIndex: "",
      pageNumber: null,
      totalPages: null,
      date: null,
      startReleasedata: null,
      endReleasedata: null,
    };
  },
  methods: {
    handleDate(modelData) {
      if (!modelData) {
        this.startReleasedata = null;
        this.endReleasedata = null;
        this.filterMoviesBaseReleaseData();
      } else {
        this.startReleasedata = this.convert(modelData[0].toString());
        this.endReleasedata = this.convert(modelData[1].toString());
      }
    },
    filterMoviesBaseReleaseData() {
      var query = "";
      if (!this.startReleasedata && !this.endReleasedata) {
        query = "";
        this.$store.commit("setReleaseDate", [null, null]);
      } else {
        query = `&release_date.gte=${this.startReleasedata}&release_date.lte=${this.endReleasedata}&sort_by=release_date.desc&region=US`;
        this.$store.commit("setReleaseDate", this.date);
      }
      this.$store.commit("setQuery", query);

      this.retrieveMovies(query);
    },
    convert(str) {
      var mnths = {
          Jan: "01",
          Feb: "02",
          Mar: "03",
          Apr: "04",
          May: "05",
          Jun: "06",
          Jul: "07",
          Aug: "08",
          Sep: "09",
          Oct: "10",
          Nov: "11",
          Dec: "12",
        },
        date = str.split(" ");

      return [date[3], mnths[date[1]], date[2]].join("-");
    },
    changePage(pageNumber) {
      var query = "";

      if (!this.startDate && !this.endDate) {
        query = `&page=${pageNumber}`;
        this.retrieveMovies(query);
        this.$store.commit("setQuery", query);
      } else {
        var sd = this.convert(this.startDate.toString());
        var ed = this.convert(this.endDate.toString());
        query = `&page=${pageNumber}&release_date.gte=${sd}&release_date.lte=${ed}&sort_by=release_date.desc&region=US`;
        this.retrieveMovies(query);
        this.$store.commit("setQuery", query);
      }
    },
    async retrieveMovies(query) {
      this.$store.commit("setLoadingStatus", true);

      await MovieDataService.getAll(query)
        .then((response) => {
          this.$nextTick(() => {
            window.scrollTo({
              top: 0,
              behavior: "smooth",
            });
          });
          this.moviesResponse = response.data;
          this.movies = this.moviesResponse.results;
          this.movies.forEach((movie) => {
            movie.genre_names = this.getGenereTitleFromGenereId(
              movie.genre_ids
            );
          });
          this.pageNumber = this.moviesResponse.page;
          this.totalPages = this.moviesResponse.total_pages;
          this.getResultIndex(
            this.moviesResponse.page,
            this.moviesResponse.total_pages,
            this.moviesResponse.total_results,
            this.movies.length
          );
          this.$store.commit("setLoadingStatus", false);
        })
        .catch((e) => {
          this.$store.commit("setLoadingStatus", false);
          this.$swal.fire({
            icon: "error",
            title: "Oops...",
            text: e.message,
          });
          console.log(e);
        });
    },
    getGenereTitleFromGenereId(generes) {
      var movieGenere = [];

      generes.forEach((genere) => {
        movieGenere.push(
          this.allGeneres.filter((item) => item.id == genere)[0]
        );
      });
      return movieGenere;
    },
    retrieveAllgenere() {
      MovieDataService.getAllGenere()
        .then((response) => {
          this.allGeneres = response.data.genres;

        })
        .catch((e) => {
          console.log(e);
        });
    },
    getResultIndex(pageNumber, totalPages, totalResults, moviesCount) {
      /* eslint-disable no-unused-vars */
      var startIndex = 0;
      var lastIndex = 0;
      //no movie to show in list
      if (moviesCount == 0) {
        this.resultIndex = "";

        //atleast one movie to show in list
      } else {
        //pageNumber is 1
        if (pageNumber == 1) {
          startIndex = 1;
          if (moviesCount > 1) {
            lastIndex = moviesCount;
          }
          //pageNumber is more than 1
        } else {
          startIndex = pageNumber * 10 + 1;
          lastIndex = startIndex + 19;
        }

        //
        if (lastIndex == 0) {
          this.resultIndex = `${startIndex}`;
        } else {
          this.resultIndex = `${startIndex}-${lastIndex}`;
        }
      }
      /* eslint-enable no-unused-vars */
    },
   

   

    setInitialDates() {
      if (!this.startDate && !this.endDate) {
        return;
      } else {
        var startDate = this.startDate;
        var endDate = this.endDate;
        this.date = [startDate, endDate];
      }
    },
  },
  computed: {
    urlQuery() {
      return this.$store.state.query;
    },
    startDate() {
      return this.$store.state.startReleaseDate;
    },
    endDate() {
      return this.$store.state.endReleaseDate;
    },
    prevPageIsDisabled() {
      return this.pageNumber == 1 || this.totalPages == 0;
    },
  },
  mounted() {
    this.retrieveAllgenere();

    this.retrieveMovies(this.urlQuery);
    this.setInitialDates();
  },
};
</script>
